(*::::::::::::::::::::::::::::::::::::::::::::::::::::::::*)
(*:: Misc-stuff functions (c) by Sergey Korowkin, 1998. ::*)
(*::   Partially from tpString unit (c) by TurboPower.  ::*)
(*::::::::::::::::::::::::::::::::::::::::::::::::::::::::*)
unit Wizard;

interface
uses
{$IFDEF OS2}
     Use32,
     DoNotUse32,
     Dos;
{$ELSE}
     Dos;
{$ENDIF}

type
 CharSet = set of Char;
const
 DosDelimSet : set of Char = ['\', ':', #0];

function stUpcase(S: String): String;
function stLocase(S: String): String;
function Long2Str(L: Longint): String;
procedure Str2Byte(S: String; var A: Byte);
procedure Str2Word(S: String; var A: Word);
procedure Str2Longint(S: String; var A: Longint);
function WordCount(S : string; WordDelims : CharSet) : Byte;
function ExtractWord(N : Byte; S : string; WordDelims : CharSet) : string;
function AddBackSlash(S: String): String;
function RTrim(S: String): String;
function LTrim(S: String): String;
function Trim(S: String): String;
function PadCh(S : string; Ch : Char; Len : Byte) : string;
function Pad(S : string; Len : Byte) : string;
function LeftPadCh(S : string; Ch : Char; Len : Byte) : string;
function LeftPad(S : string; Len : Byte) : string;
function JustFilename(PathName : string) : string;
function JustPathname(PathName : string) : string;
function JustExtension(Name : string) : string;
function HasExtension(Name : string; var DotPos : Word) : Boolean;
function ForceExtension(Name, Ext: string): string;
function ExistFile(S: String): Boolean;
function ExistDir(S: String): Boolean;
function HexB(B: Byte): string;
function HexW(W: Word): string;
function HexL(L: LongInt): string;
function HexPtr(P: Pointer): string;
function Replace(_Source, _What, _To: String): String;
function Center(S : string; Width : Byte) : string;
function CenterCh(S : string; Ch : Char; Width : Byte) : string;
function GetPString(S: Pointer): String;

implementation

function UpCase(c: char): char;                 {1996 year}
 begin;
  case c of
   'a'..'z': c:=chr(ord(c)-(97-65));
   ''..'': c:=chr(ord(c)-(160-128));
   ''..'': c:=chr(ord(c)-(224-144));
   '': c:='';
  end;
  upCase:=c;
 end;

function LoCase(c: char): char;                 {1996 year}
 begin;
  case c of
   'A'..'Z': c:=chr(ord(c)+(97-65));
   ''..'': c:=chr(ord(c)+(160-128));
   ''..'': c:=chr(ord(c)+(224-144));
   '': c:='';
  end;
  loCase:=c;
 end;

function stUpcase;
 var
  k: byte;
 begin
  for k:=1 to ord(s[0]) do
   s[k]:=upcase(s[k]);
  stUpcase:=S;
 end;

function stLocase;
 var
  k: byte;
 begin
  for k:=1 to ord(s[0]) do
   s[k]:=locase(s[k]);
  stLocase:=S;
 end;

function Long2Str;
 var
  S: String;
 begin
  Str(L, S);
  Long2str:=S;
 end;

var
{$IFDEF OS2}
 L: Longint;
{$ELSE}
 L: Word;
{$ENDIF}

procedure Str2Word;
 begin
  Val(S,A,L);
 end;

procedure Str2Byte;
 begin
  Val(S,A,L);
 end;

procedure Str2Longint;
 begin
  Val(S,A,L);
 end;

function WordCount(S : string; WordDelims : CharSet) : Byte;
var
 Count : Byte;
 I : Word;
 SLen : Byte absolute S;
begin
 Count := 0;
 I := 1;
 while I <= SLen do begin
  while (I <= SLen) and (S[I] in WordDelims) do
   Inc(I);
   if I <= SLen then Inc(Count);
   while (I <= SLen) and not(S[I] in WordDelims) do
    Inc(I);
   end;
  WordCount := Count;
 end;

function ExtractWord(N : Byte; S : string; WordDelims : CharSet) : string;
var
 I: Word;
 Count, Len: Byte;
 SLen: Byte absolute S;
begin
 Count := 0;
 I := 1;
 Len := 0;
 ExtractWord[0] := #0;
 while (I <= SLen) and (Count <> N) do begin
  while (I <= SLen) and (S[I] in WordDelims) do
   Inc(I);
   if I <= SLen then Inc(Count);
    while (I <= SLen) and not(S[I] in WordDelims) do begin
     if Count = N then begin
      Inc(Len);
      ExtractWord[0] := Char(Len);
      ExtractWord[Len] := S[I];
     end;
     Inc(I);
    end;
  end;
end;

function AddBackSlash;

 begin
  if S[Byte(S[0])]<>'\' then S:=S+'\';
  AddBackSlash:=S;
 end;

function LTrim(S: String): String;
 begin
  while (S[0]<>#0) and (S[1]=' ') do Delete(S,1,1);
  LTrim:=S;
 end;

function RTrim(S: String): String;
 begin
  while (S[0]<>#0) and (S[Byte(S[0])]=' ') do Dec(S[0]);
  RTrim:=S;
 end;

function Trim;
 begin
  Trim:=LTrim(RTrim(S));
 end;

function PadCh(S : string; Ch : Char; Len : Byte) : string;
  {-Return a string right-padded to length len with ch}
var
  o : string;
  SLen : Byte absolute S;
begin
  if Length(S) >= Len then
    PadCh := S
  else begin
    o[0] := Chr(Len);
    Move(S[1], o[1], SLen);
    if SLen < 255 then
      FillChar(o[Succ(SLen)], Len-SLen, Ch);
    PadCh := o;
  end;
end;
 function Pad(S : string; Len : Byte) : string;
  {-Return a string right-padded to length len with blanks}
begin
  Pad := PadCh(S, ' ', Len);
end;
 function LeftPadCh(S : string; Ch : Char; Len : Byte) : string;
  {-Return a string left-padded to length len with ch}
var
  o : string;
  SLen : Byte absolute S;
begin
  if Length(S) >= Len then
    LeftPadCh := S
  else if SLen < 255 then begin
    o[0] := Chr(Len);
    Move(S[1], o[Succ(Word(Len))-SLen], SLen);
    FillChar(o[1], Len-SLen, Ch);
    LeftPadCh := o;
  end;
end;

function LeftPad(S : string; Len : Byte) : string;
begin
 LeftPad:=LeftPadCh(S, ' ', Len);
end;

function JustExtension(Name: string): string;
var
  DotPos: Word;
begin
 if HasExtension(Name, DotPos) then
  JustExtension:=Copy(Name, Succ(DotPos), 3)
 else
  JustExtension[0] := #0;
end;

function JustFilename(PathName : string) : string;
 var
  I : Word;
begin
 I := Succ(Word(Length(PathName)));
 repeat
  Dec(I);
 until (PathName[I] in DosDelimSet) or (I = 0);
 JustFilename := Copy(PathName, Succ(I), 64);
end;

function JustPathname(PathName : string) : string;
var
 I : Word;
begin
 I := Succ(Word(Length(PathName)));
 repeat Dec(I); until (PathName[I] in DosDelimSet) or (I = 0);
 if I = 0 then JustPathname[0] := #0
 else if I = 1 then JustPathname := PathName[1]
 else if (PathName[I] = '\') then begin
 if PathName[Pred(I)] = ':' then JustPathname := Copy(PathName, 1, I)
 else JustPathname := Copy(PathName, 1, Pred(I));
 end else JustPathname := Copy(PathName, 1, I);
end;

function HasExtension(Name : string; var DotPos : Word) : Boolean;
var
 I : Word;
begin
 DotPos := 0;
 for I := Length(Name) downto 1 do
  if (Name[I] = '.') and (DotPos = 0) then
    DotPos := I;
 HasExtension := (DotPos > 0) and (Pos('\', Copy(Name, Succ(DotPos), 64)) = 0);
end;

function ForceExtension(Name, Ext : string) : string;
var
 DotPos : Word;
begin
 if HasExtension(Name, DotPos) then
  ForceExtension := Copy(Name, 1, DotPos)+Ext
 else
  ForceExtension := Name+'.'+Ext;
end;

function ExistFile(S: String): Boolean;
 var
  F: File;
{$IFDEF OS2}
  A: Use32.Word;
{$ELSE}
  A: Word;
{$ENDIF}
 begin
  Assign(F,S);
  GetFAttr(F,A);
  ExistFile:=DosError=0;
 end;

const
  Digits : array[0..$F] of Char = '0123456789ABCDEF';
type
 Long =
  record
   LowWord, HighWord : Word;
  end;

function HexB(B : Byte) : string;
 begin
  HexB[0]:=#2;
  HexB[1]:=Digits[B shr 4];
  HexB[2]:=Digits[B and $F];
 end;

function HexW(W : Word) : string;
 begin
  HexW[0]:=#4;
  HexW[1]:=Digits[hi(W) shr 4];
  HexW[2]:=Digits[hi(W) and $F];
  HexW[3]:=Digits[lo(W) shr 4];
  HexW[4]:=Digits[lo(W) and $F];
 end;

function HexL(L : LongInt) : string;
 begin
  with Long(L) do
   HexL:=HexW(HighWord)+HexW(LowWord);
 end;

function HexPtr(P : Pointer) : string;
 begin
  HexPtr:=HexW(Seg(P^))+':'+HexW(Ofs(P^));
 end;

function ExistDir(S: String): Boolean;
 var
  SR: SearchRec;
 begin
  FindFirst(AddBackSlash(S)+'*.*',AnyFile,SR);
  ExistDir:=DosError=0;
 end;

function Replace(_Source, _What, _To: String): String;
 var
  I: Integer;
  X: Integer;
 begin
  _What:=StUpcase(_What); X:=0;
  repeat
   Inc(X);
   if X=50 then Break;
   I:=Pos(_What, StUpcase(_Source));
   if I=0 then break;
   Delete(_Source, I, Length(_What));
   Insert(_To, _Source, I);
  until 1=2;
  Replace:=_Source;
 end;

function CenterCh(S : string; Ch : Char; Width : Byte) : string;
  var
    o : string;
    SLen : Byte absolute S;
  begin
    if SLen >= Width then
      CenterCh := S
    else if SLen < 255 then begin
      o[0] := Chr(Width);
      FillChar(o[1], Width, Ch);
      Move(S[1], o[Succ((Width-SLen) shr 1)], SLen);
      CenterCh := o;
    end;
  end;

function Center(S : string; Width : Byte) : string;
 begin
  Center := CenterCh(S, ' ', Width);
 end;

function GetPString(S: Pointer): String;
 type
  PString = ^String;
 begin
  if S=Nil then
   GetPString:=''
  else
   GetPString:=PString(S)^;
 end;

end.
